
/* ----------------------------------------------------------------------
   A. Veneziani - Definizione di una classe punto e suo utilizzo
                  per definire a sua volta una classe Triangolo

                  Scritto in C++ Builder 6
   ---------------------------------------------------------------------- */               

#include <iostream>
#include <math>
#include <conio>

using namespace std;

// classe che definisce un oggetto Punto
class Punto
{
     // coordinate del punto in 2D  (private)
     float x;
     float y;

     public:

     // rende la coordinata x del punto
     float dai_x()
     {
         return(x);
     }

     // rende la coordinata y del punto     
     float dai_y()
     {
         return(y);
     }

     // definisce la posizione del punto assegnando due coordinate
     void setta_punto(float xp, float yp)
     {
         x = xp;
         y = yp;
     }

     // metodo che calcola la distanza fra due punti
     float distanza_punti(Punto p)
     {
         float d;

         d = sqrt(pow(x - p.x,2) + pow(y - p.y,2));

         return(d);
     }
};

// classe Triangolo (sfrutta alcune funzionalita'
// della classe Punto e utilizza oggetti Punto per
// definire un oggetto Triangolo
class Triangolo
{
     Punto p1, p2, p3;     // i tre punti vertici del triangolo

     public:

     // definisce il triangolo
     void definisci_tr(Punto pnt1, Punto pnt2, Punto pnt3)
     {
         p1.setta_punto(pnt1.dai_x(), pnt1.dai_y());
         p2.setta_punto(pnt2.dai_x(), pnt2.dai_y());
         p3.setta_punto(pnt3.dai_x(), pnt3.dai_y());
     }

     // calcola il perimetro utilizzando metodi dell'oggetto Punto
     float perimetro()
     {
         float d1, d2, d3;

         // calcolo delle distanze tra i vari punti
         d1 = p1.distanza_punti(p2);
         d2 = p2.distanza_punti(p3);
         d3 = p3.distanza_punti(p1);

         // ritorna la somma delle distanze, cioe' il perimetro
         return(d1 + d2 + d3);
     }

     // calcola l'area calcolando l'altezza tirata
     // su d3 e considerando d3 base
     float area()
     {
         float b1, h;
         float d1, d2, d3;

         // calcolo delle distanze tra i vari punti
         d1 = p2.distanza_punti(p3);
         d2 = p3.distanza_punti(p1);
         d3 = p1.distanza_punti(p2);

         // proiezione sul segmento d3, del segmento d1
         b1 =  (pow(d3,2) + pow(d2,2) - pow(d1,2)) / (2 * d3);

         // altezza tirata dal punto 2 verso d3
         h = sqrt(pow(d2, 2) - pow(b1,2));

         // calcola l'area e la rende
         return (h * d3 / 2);
     }
};

int main()
{
    Punto pt1, pt2, pt3;
    Triangolo tr;

    // fissa i tre punti che definiranno il trangolo
    pt1.setta_punto(0,0);
    pt2.setta_punto(3,0);
    pt3.setta_punto(1.5,3);

    // definisce il triangolo in base ai tre punti
    // precedentemente fissati
    tr.definisci_tr(pt1, pt2, pt3);

    // calcola alcune caratteristiche del triangolo
    // applicando opportuni metodi
    cout << "Il perimetro del triangolo e':  " << tr.perimetro() << endl;

    cout << "L'area del triangolo e':  " << tr.area() << endl;    

    getch();        // attende un carattere prima di proseguire
    
    return(0);
}

 